var SF_ZEMANTA = {
	key : "28a6f3wecu85fa9g3svaypsq",
	prefs : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("performancing."),
	rid : null,
	
	zprefs : null,
	signature : "",
	
	signatureInserted : false,
	
	lastImage : null,
	
	getAPIKey : function () {
		var storedKey = this.prefs.getCharPref("zemanta.key");
		
		if (storedKey == this.key) {
		    storedKey = "";
		    this.prefs.setCharPref("zemanta.key", "");
		}
		
		if (!storedKey) {
			var postData = "method=zemanta.get_auth_token";
			postData += "&api_key="+this.key;
			postData += "&partner_id=sf-000014";
			postData += "&format=json";
		    
		    try {
    			var req = new XMLHttpRequest();
    			req.open("POST", "http://api.zemanta.com/services/rest/0.0/", false);
    			req.setRequestHeader("Content-Length", postData.length);
    			req.send(postData);
	        
    			try {
    				var json = SCRIBEFIRE_JSON.fromString(req.responseText);
    				storedKey = json.api_key;
    				this.prefs.setCharPref("zemanta.key", storedKey);
    			} catch (e) {
    			    alert(e);
    				storedKey = this.key;
    			}
		    } catch (e) {
		        alert(e);
		        storedKey = this.key;
	        }
		}
		
		return storedKey;
	},
	
	getZemantaPrefs : function () {
		if (this.zprefs) return this.zprefs;
		
		var key = this.getAPIKey();
		
		var postData = "method=zemanta.preferences";
		postData += "&api_key="+key;
		postData += "&interface=scribefire";
		postData += "&deployment=" + encodeURIComponent("ScribeFire " + this.prefs.getCharPref("version"));
		postData += "&format=json";
	    
	    try {
    		var req = new XMLHttpRequest();
    		req.open("POST", "http://api.zemanta.com/services/rest/0.0/", false);
    		req.setRequestHeader("Content-Length", postData.length);
    		req.send(postData);
    		
			var json = SCRIBEFIRE_JSON.fromString(req.responseText);
			this.zprefs = json;

			this.prefs.setCharPref("zemanta.config_url", json.config_url);
    	} catch (e) {
    	    alert("An error occurred while retrieving your preferences from Zemanta:\n\n" + e);
	    }
		
		return this.zprefs;
	},
	
	managePrefs : function () {
		parent.parent.getWebBrowser().selectedTab = parent.parent.getWebBrowser().addTab(this.prefs.getCharPref("zemanta.config_url"));
	},
	
	getSelectedContent : function () {
		var selectedTab = document.getElementById("performancing-editor-tabbox").selectedIndex;
		var content = "";
		
		if (selectedTab == '1'){
			var box = document.getElementById("performancing-message-source");
			var start = box.selectionStart;
			var selection = box.value.substring(start, box.selectionEnd);
			selection = selection.replace(/<br\s*\/?>/g, "\n");
			selection = selection.replace(/<\/?p>/g, "\n");
			content = selection.replace(/<[^>]+>/g, " ");
		}
		else {
			var midas = document.getElementById("performancing-message");
			var oRange = getContentWindow(midas).getSelection().getRangeAt(0);
			content = oRange.textContent;
		}
		
		if (!content) {
			content = pffEditorUI.parentWindow.performancingEditor.getContent();
			content = content.replace(/<div class="zemanta-articles">[\s\S]+<\/ul><\/div>/gi,"")
			content = content.replace(/<div class="zemanta-image"[\s\S]+<\/small><\/div>/gi, "");
		}
		
		return content;
	},
	
	getRelated : function (type, content) {
	    if (!this.prefs.getBoolPref("zemanta.tos")) {
	        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                    .getService(Components.interfaces.nsIPromptService);
            var check = {value: false};
            var flags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_OK + 
                prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_CANCEL +
                prompts.BUTTON_POS_2 * prompts.BUTTON_TITLE_IS_STRING +
                prompts.BUTTON_POS_0_DEFAULT;

            var button = prompts.confirmEx(window, 
                    performancingUI.getLocaleString("zemanta.tosTitle"),
                    performancingUI.getLocaleString("zemanta.tosAgree"),
                    flags, 
                    "", 
                    "", 
                    performancingUI.getLocaleString("zemanta.viewTos"),
                    null, 
                    check);
            
            if (button == 0) {
                this.prefs.setBoolPref("zemanta.tos", true);
            }
            else if (button == 1) {
    			document.getElementById('zemanta-articles-button').removeAttribute("busy");
    			document.getElementById("image-button").removeAttribute("busy");
    			return;
            }
            else {
                parent.parent.getWebBrowser().selectedTab = parent.parent.getWebBrowser().addTab('http://www.zemanta.com/tos/');
                return;
            }
        }
        
		if (type == 'images') document.getElementById("image-button").setAttribute("busy","true");
		else if (type == 'articles') document.getElementById('zemanta-articles-button').setAttribute("busy", "true");
		
		if (!content) content = this.getSelectedContent();
		
		var apiKey = this.getAPIKey();
		var zprefs = this.getZemantaPrefs();
		
		var req = new XMLHttpRequest();
		req.open("POST", "http://api.zemanta.com/services/rest/0.0/", true);
		req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		
		var postData = "method=zemanta.suggest&api_key=" + apiKey + "&format=json&text=";
		postData += encodeURIComponent(content);
		
		postData += "&pixie="+encodeURIComponent(zprefs.pixie);
		postData += "&social_timestamp=" + encodeURIComponent(zprefs.social_timestamp);
		postData += "&flickr_user_id=" + encodeURIComponent(zprefs.flickr_user_id);
		postData += "&sourcefeed_ids=" + encodeURIComponent(zprefs.sourcefeed_ids);
		
		if (this.rid) {
		    postData += "&post_rid=" + encodeURIComponent(this.rid);
	    }
		
		switch (type) {
			case 'articles':
				postData += "&return_images=0";
			break;
			case 'images':
    			var deck = parent.document.getElementById("zemanta-grid-deck");
    			while (deck.firstChild) deck.removeChild(deck.firstChild);
			break;
		}
		
		req.setRequestHeader("Content-Length", postData.length);
		
		req.onreadystatechange = function () {
			if (req.readyState == 4) {
				// Insert the articles.
				var json = SCRIBEFIRE_JSON.fromString(req.responseText);
				
				SF_ZEMANTA.signature = json.signature;
				
				if (type == "articles") {
					var articles = json.articles;
					
					if (articles && articles.length > 0) {
						var container = parent.document.getElementById("zemanta-articles-container");
						while (container.firstChild) container.removeChild(container.firstChild);
						
						parent.document.getElementById("sidebar-deck").selectedIndex = 2;
						parent.document.getElementById("sidebar-deck").style.width = "320px";
						parent.document.getElementById("sidebar-deck").collapsed = false;
						
						var utcMS = new Date().getTime();
						
						for (var i = 0; i < articles.length; i++) {
							var item = parent.document.getElementById("zemanta-article-template").cloneNode(true);
							item.style.display = "";
							item.id = "";
							
							item.reference = articles[i];
							
							var desc = item.getElementsByTagName("description")[0];
							desc.appendChild(parent.document.createTextNode(articles[i].title));
							
							var time = articles[i].published_datetime;
							var date = new Date();
							
							date.setFullYear(time.substr(0,4));
							date.setMonth(parseInt(time.substr(5,2), 10) - 1);
							date.setDate(time.substr(8,2));
							date.setHours(time.substr(11,2));
							date.setMinutes(time.substr(14,2));
							
							var articleMS = date.getTime();
							
							var difference = Math.floor((utcMS - articleMS) / 1000 / 60);
							
							var dateString = "";
							
							if (difference <= 1) {
								dateString += performancingUI.getLocaleString("time.inSeconds");
							}
							else if (difference < 60) {
								dateString += performancingUI.getLocaleString("time.inMinutes", [ difference ]);
							}
							else if (difference < 60 * 24) {
							    dateString += performancingUI.getLocaleString("time.inHours", [ Math.round(difference / 60) ]);
							}
							else {
							    dateString += performancingUI.getLocaleString("time.inDays", [ Math.round(difference /  60 / 24) ]);
							}
							
							item.getElementsByTagName("label")[0].appendChild(parent.document.createTextNode(dateString));
							item.getElementsByTagName("label")[1].href = articles[i].url;
							item.style.padding = "5px";
							item.style.marginBottom = "5px";
							item.style.borderWidth = '5px';
							
							item.style.borderColor = '#ccc';
							item.style.borderStyle = 'solid';
							
							if (i < 4) {
								item.setAttribute("active","true");
							}
							else {
								item.setAttribute("active","false");
							}
							
							item.setAttribute('onclick','if (this.getAttribute("active") == "false") { this.setAttribute("active","true"); } else { this.setAttribute("active","false"); } performancingEditor.insertZemantaArticles();');
							
							container.appendChild(item);
						}
						
						parent.document.getElementById('zemanta-articles-refresh').removeAttribute("busy");
						parent.performancingEditor.insertZemantaArticles();
					}
					else {
						alert(performancingUI.getLocaleString("zemanta.noArticles"));
					}
				} else if (type == "images") {
					var images = json.images;
					
					if (images && images.length > 0) {
						var deck = parent.document.getElementById("zemanta-grid-deck");
						var grid = parent.document.getElementById("zemanta-image-grid");
						
						parent.document.getElementById("sidebar-deck").selectedIndex = 1;
						parent.document.getElementById("sidebar-deck").style.width = "320px";
						parent.document.getElementById("sidebar-deck").collapsed = false;
						deck.selectedIndex = 0;
						
						for (var i = 0; i < images.length; i++) {
							if (i % 9 == 0) {
								var currentGrid = grid.cloneNode(true);
								currentGrid.style.display = "block";
								currentGrid.id = "";
								deck.appendChild(currentGrid);
							}
							
							if (i % 3 == 0) {
								var currentRow = parent.document.createElement("row");
								currentGrid.getElementsByTagName("rows")[0].appendChild(currentRow);
							}
							
							var currentImage = parent.document.createElement("image");
							currentImage.setAttribute("src", images[i].url_s);
							currentImage.setAttribute('onclick','var images = document.getElementById("zemanta-grid-deck").getElementsByTagName("image"); for (var i = 0; i < images.length; i++) { images[i].style.borderColor = "transparent"; } this.style.borderColor = "#FF9800"; performancingEditor.insertZemantaImage(this);');
							currentImage.setAttribute("tooltiptext", images[i].license);
							currentImage.reference = images[i];
							currentRow.appendChild(currentImage);
						}
						
						parent.document.getElementById('zemanta-image-pagelabel').value = "1 / " + Math.ceil(images.length / 9);
						parent.document.getElementById('zemanta-image-refresh').removeAttribute("busy");
					}
					else {
						alert(performancingUI.getLocaleString("zemanta.noImages"));
					}
				}
				
				document.getElementById('zemanta-articles-button').removeAttribute("busy");
				document.getElementById("image-button").removeAttribute("busy");
			}
		};
		
		req.send(postData);
	},
	
	addUniversalTracker : function (callback) {
	    if (!this.signatureInserted && this.prefs.getBoolPref("zemanta.track")) {
	        try {
    	        var apiKey = this.getAPIKey();
        		var zprefs = this.getZemantaPrefs();
    		
        		var postData = "method=zemanta.get_signature&api_key="+apiKey+"&pixie=301&format=json";
    		
        		var req = new XMLHttpRequest();
        		req.open("POST", "http://api.zemanta.com/services/rest/0.0/", false);
        		req.setRequestHeader("Content-Length", postData.length);
        		req.send(postData)
    		
        		var json = SCRIBEFIRE_JSON.fromString(req.responseText);
        		this.signature = json.signature;
        		this.rid = json.rid;
    		    
    		    var p = parent;
    		    
    		    if (p.wrappedJSObject) p = p.wrappedJSObject;
    		    
        		p.performancingEditor.insertZemantaSignature(callback);
        	} catch (e) {
        	    alert(e);
        	    
        	    callback();
    	    }
	    }
	    else {
	        callback();
	    }
    }
};